> ## Documentation Index
> Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt
> Use this file to discover all available pages before exploring further.
# Get design pages
Get the metadata for pages in a design.
This API is currently provided as a preview. Be aware of the following:
* There might be unannounced breaking changes.
* Any breaking changes to preview APIs won't produce a new [API version](https://www.canva.dev/docs/apps/rest-apis/versions/).
* Public apps that use preview APIs will not pass the review process, and can't be made available to all Canva users.
Lists metadata for pages in a design, such as page-specific thumbnails.
For the specified design, you can provide `offset` and `limit` values to specify the range of pages to return.
NOTE: Some design types don't have pages (for example, Canva docs).
## HTTP method and URL path
GET https\://api.canva.com/rest/v1/designs/\{designId}/pages
This operation is rate limited to 100 requests per minute for each user of your app.
## Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token).
### Scopes
The access token must have all the following [scopes](/docs/apps/rest-apis/scopes) (permissions):
* `design:content:read`
## Header parameters
Provides credentials to authenticate the request, in the form of a `Bearer` token.
For example: `Authorization: Bearer {token}`
## Path parameters
The design ID.
## Query parameters
The page index to start the range of pages to return.
Pages are indexed using one-based numbering, so the first page in a design has the index value `1`.
**Minimum:** `1`
**Maximum:** `500`
**Default value:** `1`
The number of pages to return, starting at the page index specified using the `offset` parameter.
**Minimum:** `1`
**Maximum:** `200`
**Default value:** `50`
## Example request
Examples for using the `/v1/designs/{designId}/pages` endpoint:
```sh
curl --request GET 'https://api.canva.com/rest/v1/designs/{designId}/pages' \
--header 'Authorization: Bearer {token}'
```
```js
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/designs/{designId}/pages", {
method: "GET",
headers: {
"Authorization": "Bearer {token}",
},
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
```
```java
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/designs/{designId}/pages"))
.header("Authorization", "Bearer {token}")
.method("GET", HttpRequest.BodyPublishers.noBody())
.build();
HttpResponse response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
```
```py
import requests
headers = {
"Authorization": "Bearer {token}"
}
response = requests.get("https://api.canva.com/rest/v1/designs/{designId}/pages",
headers=headers
)
print(response.json())
```
```csharp
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Get,
RequestUri = new Uri("https://api.canva.com/rest/v1/designs/{designId}/pages"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
```
```go
package main
import (
"fmt"
"io"
"net/http"
)
func main() {
url := "https://api.canva.com/rest/v1/designs/{designId}/pages"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("Authorization", "Bearer {token}")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
```
```php
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/designs/{designId}/pages",
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
),
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
```
```ruby
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/designs/{designId}/pages')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request['Authorization'] = 'Bearer {token}'
response = http.request(request)
puts response.read_body
```
## Success response
If successful, the endpoint returns a `200` response with a JSON body with the following parameters:
The list of pages.
Properties of items>} defaultExpanded={true}>
The 1-based page number within the design. The first page in a design has the value `1`.
**Minimum:** `1`
**Maximum:** `500`
The type of content a design or page contains. The list of design types may grow over time. The `unknown` value represents design types that haven't been added to the list.
**Available values:**
* `doc`
* `email`
* `presentation`
* `sheet`
* `whiteboard`
* `custom`
* `unknown`
The ID of the page. This ID is unique within the design and can be used to
correlate a page with per-page data from other APIs.
Some designs might not have page IDs, in which case this property is omitted.
The dimensions of a design page, if it is bounded. Design pages for non-bounded designs like Whiteboards and Docs will not include this property.
Properties of dimensions>}>
The width of the design page in pixels.
The height of the design page in pixels.
A thumbnail image representing the object.
Properties of thumbnail>}>
The width of the thumbnail image in pixels.
The height of the thumbnail image in pixels.
A URL for retrieving the thumbnail image.
This URL expires after 15 minutes. This URL includes a query string
that's required for retrieving the thumbnail.
WARNING: This property is deprecated. Use `page_number` instead, which returns an identical value.
The index of the page in the design. The first page in a design has the index value `1`.
**Minimum:** `1`
**Maximum:** `500`
## Example response
```json
{
"items": [
{
"id": "PB2NFQ9W78kLDFCK",
"page_number": 1,
"dimensions": {
"width": 595,
"height": 1295
},
"thumbnail": {
"width": 595,
"height": 335,
"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?"
},
"design_type": "presentation"
}
]
}
```
## Error responses
### 400 Bad Request
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### Canva docs don't have pages
```json
{
"code": "page_not_found",
"message": "Design {designId} has no pages because it's a Canva doc."
}
```
##### The offset is outside the range of pages in the design
```json
{
"code": "offset_too_large",
"message": "Offset {offset} is outside range of [1, {pageCount}]"
}
```
### 403 Forbidden
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### Not allowed to access the design
```json
{
"code": "permission_denied",
"message": "Not allowed to access design"
}
```
### 404 Not Found
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### The design was not found
```json
{
"code": "design_not_found",
"message": "Design with id '{designId}' not found"
}
```